// Last LITERAL weapon that we had selected
// This works REGARDLESS even if it's not in the list!
str lastWeapon[MAXPLAYERS];

// The current weapon index for the gun we have selected
int curWeaponIndex[MAXPLAYERS];

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// LASTWEAPONHANDLER
// This script loops over and over again, stores our last wep
//
// The variables are likely set on the server and not replicated
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

script "LastWeaponHandler" (void)
{
    int pn            = PlayerNumber();
    str currentWeapon = GetWeapon();
	str temp;
	int switchFix = 0;
	int tempID;
    lastWeapon[pn]    = currentWeapon;
	
	WeaponSwitched();

    while (ClassifyActor(0) & ACTOR_ALIVE)
    {
		str GW = GetWeapon();
		
		// We don't want to quick-swap BACK to these
		if (StrICmp(GW, "Syringe") == 0 || StrICmp(GW, "MenuWeapon") == 0)
		{
			if (!switchFix)
			{
				switchFix = 1;
				temp = currentWeapon;
				tempID = WeaponByType(GW);
				currentWeapon = lastWeapon[pn];
				lastWeapon[pn] = temp;
			}
		}
		
		// Anything beside those
		else
		{
			// The strings are different!
			if (StrICmp(currentWeapon, GW))
			{
				lastWeapon[pn] = currentWeapon;
				WeaponSwitched();
			}
			switchFix = 0;
			currentWeapon = GW;
		}
		
		
        Delay(1);
    }
}

// We switched to a new weapon!
void WeaponSwitched() 
{ 
	curWeaponIndex[PlayerNumber()] = WeaponByType( GetWeapon() );
}

// Switch to the last weapon we had selected
void SwitchToLast()
{
    int pn = PlayerNumber();
    SetWeapon(lastWeapon[pn]);
}

// PUKABLE
script "LastWeapon" (void) net { SwitchToLast(); }